vexbindings = {}
vexbindings.bindings = {}
vexbindings.loaded = false
SLASH_VEXBINDINGS1 = "/vexbindings"
SLASH_VEXBINDINGS2 = "/vexb"
function SlashCmdList.VEXBINDINGS(msg, editbox)
	local command, args = msg:match("^(%S*)%s*(.-)$")
	if command == "save" or command == "Save" then							-- save
		vexbindings_SaveBindingProfile(args)
	elseif command == "delete" or command == "Delete" then					-- delete
		vexbindings_DeleteBindingProfile(args)
	elseif command == "load" or command == "Load"  then						-- load
		local arg1, arg2 = args:match("^(%S*)%s*(.-)$")
		vexbindings_LoadBindingProfile(arg1, arg2)
	elseif command == "list" or command == "List"  then						-- list
		vexbindings_ListBindingProfiles()
	elseif command == "setSpec" or command == "SetSpec"  then				-- setSpec
		local arg1, arg2 = args:match("^(%S*)%s*(.-)$")
		vexbindings_SaveSpecBinding(arg1, arg2)
	elseif command == "loadAs" or command == "loadAs"  then					-- loadAs
		vexbindings_SaveSpecConfig(args)
	elseif command == "getLoadAs" or command == "GetLoadAs"  then			-- getLoadAs
		vexbindings_GetSaveSpecConfig()
	elseif command == "getSpec" or command == "GetSpec"  then				-- getSpec
		vexbindings_GetBothSpecBindings()
	elseif command == "deSpec" or command == "DeSpec"  then					-- deSpec
		vexbindings_DeSpecBinding(args)
	elseif command == "getX" or command == "GetX"  then						-- getX
		vexbindings_GetCurrentSpec()
	elseif command == "test" then											-- test
		vexdebugs.print(vexbindings.loaded,"vexbindings.loaded")
	elseif command == "help" or command == "Help" then						-- help
		print(" ")
		print("|CFFFF7D0A Vex Bindings|r cmd list")
		print("|CFFFF7D0A/vexbindings|r and |CFFFF7D0A/vexb|r can be used")
		if args == "sets" or args == "Sets" then
			print("|CFFFF7D0A/vexb|r |CFFa52a2asave NAME|r - saves the current binding as a set with the name 'NAME'")
			print("|CFFFF7D0A/vexb|r |CFFa52a2adelete NAME|r - deletes the binding as a set with the name 'NAME'")
			print("|CFFFF7D0A/vexb|r |CFFa52a2aload NAME|r - loads the binding-set with the name 'NAME' as a temporary binding set (will be resetted after ui reload)")
			print("|CFFFF7D0A/vexb|r |CFFa52a2aload NAME g|r - loads the binding-set with the name 'NAME' as a global binding set")
			print("|CFFFF7D0A/vexb|r |CFFa52a2aload NAME s|r - loads the binding-set with the name 'NAME' as a character specific binding set")
			print("|CFFFF7D0A/vexb|r |CFFa52a2alist|r - returns a list of all saved binding-sets")
		elseif args == "specs" or args == "Specs" then
			print("|CFFFF7D0A/vexb|r |CFFa52a2agetX|r - Returns the number X (1 or 2) of the spec you currently use.")
			print("|CFFFF7D0A/vexb|r |CFFa52a2asetSpec X NAME|r - connects the spec X with the binding 'NAME'. Everytime the spec is activated the binding will be loaded")
			print("|CFFFF7D0A/vexb|r |CFFa52a2agetSpec|r - returns the names of the bindings connected to the specs")
			print("|CFFFF7D0A/vexb|r |CFFa52a2adeSpec X|r - disconnects the spec X from a binding-set")
			print("|CFFFF7D0A/vexb|r |CFFa52a2aloadAs|r - Sets will be loaded and saved as a temporary binding (will be resetted after ui reload)")
			print("|CFFFF7D0A/vexb|r |CFFa52a2aloadAs g|r - Sets will be loaded and saved as global keybindings")
			print("|CFFFF7D0A/vexb|r |CFFa52a2aloadAs s|r - Sets will be loaded and saved as character specific keybindings")
			print("|CFFFF7D0A/vexb|r |CFFa52a2agetLoadAs|r - Returns the current setting for loadAs")
		else
			print("|CFFFF7D0A/vexb|r |CFFa52a2ahelp sets|r - shows the commands to load/save binding-sets")
			print("|CFFFF7D0A/vexb|r |CFFa52a2ahelp specs|r - shows the commands to connect binding-sets to specs")
		end
	else
		print(" ")
		print("|CFFFF7D0A Vex Bindings|r cmd list")
		print("|CFFFF7D0A/vexbindings|r and |CFFFF7D0A/vexb|r can be used")
		print("|CFFFF7D0A/vexb|r |CFFa52a2ahelp sets|r - shows the commands to load/save binding-sets")
		print("|CFFFF7D0A/vexb|r |CFFa52a2ahelp specs|r - shows the commands to connect binding-sets to specs")
	end
end

function vexbindings_GetSpecNumber()
	if GetActiveSpecGroup == nil then
		return tostring(GetActiveTalentGroup(false, false))	-- OLD
	else
		return tostring(GetActiveSpecGroup(false, false))	-- MoP
	end
end

function vexbindings_SaveSpecConfig(arg)
	if arg == "s" or arg == "g" or arg == "" or arg == nil then
		vexbindings_config[3] = arg
		if arg == "g" then
			print("|CFFFF7D0A Vex Bindings|r binding-sets loaded with a talent spec change will be loaded as global keybindings")
		elseif arg == "s" then
			print("|CFFFF7D0A Vex Bindings|r binding-sets loaded with a talent spec change will be loaded as character specific keybindings")
		else
			print("|CFFFF7D0A Vex Bindings|r binding-sets loaded with a talent spec change will be loaded as a temporary binding (will be resetted after the next loading screen!)")
		end
	else
		print("|CFFFF7D0A Vex Bindings|r ERROR: Could not set loadAs! REASON: Entered loadAs value '"..arg.."' is invalid! Only 's', 'g' and '' are valid")
	end
end

function vexbindings_GetCurrentSpec()
	local number = vexbindings_GetSpecNumber()
	print("|CFFFF7D0A Vex Bindings|r Spec '"..number.."' is currently active")
end

function vexbindings_SaveSpecBinding(spec, bindingset)
	if spec == "1" or spec == "2" then
		if vexbindings_ExistsBindingProfile(bindingset) then
			vexbindings_config[spec] = bindingset
			print("|CFFFF7D0A Vex Bindings|r Spec '"..spec.."' is now connected to binding-set '"..bindingset.."'")
		else
			print("|CFFFF7D0A Vex Bindings|r ERROR: Could not connect binding-set with spec! REASON: Binding-Set '"..bindingset.."' not found")
		end
	else
		print("|CFFFF7D0A Vex Bindings|r ERROR: Could not connect binding-set with spec! REASON: Entered spec '"..spec.."' is invalid! Only '1' and '2' are valid specs")
	end
end

function vexbindings_DeSpecBinding(spec)
	if spec == "1" or spec == "2" then
		if vexbindings_config[spec] ~= nil then
			local bindingset = vexbindings_config[spec]
			vexbindings_config[spec] = nil
			print("|CFFFF7D0A Vex Bindings|r Spec '"..spec.."' is not connected to binding-set '"..bindingset.."' anymore")
		else
			print("|CFFFF7D0A Vex Bindings|r ERROR: Could not disconnect spec from binding-set! REASON: Spec '"..spec.."' has not been connected to a binding-set")
		end
	else
		print("|CFFFF7D0A Vex Bindings|r ERROR: Could not disconnect spec from binding-set! REASON: Entered spec '"..spec.."' is invalid! Only '1' and '2' are valid specs")
	end
end

function vexbindings_GetBothSpecBindings()
	vexbindings_GetSpecBinding("1")
	vexbindings_GetSpecBinding("2")
end

function vexbindings_GetSpecBinding(spec)
	if spec == "1" or spec == "2" then
		if vexbindings_config[spec] ~= nil then
			print("|CFFFF7D0A Vex Bindings|r Spec '"..spec.."' is connected to binding-set '"..vexbindings_config[spec].."'")
		else
			print("|CFFFF7D0A Vex Bindings|r Spec '"..spec.."' is not connected to a binding-set")
		end
	else
		print("|CFFFF7D0A Vex Bindings|r ERROR: Could not get binding! REASON: Entered spec '"..spec.."' is invalid! Only '1' and '2' are valid specs")
	end
end

function vexbindings_GetSaveSpecConfig()
	if vexbindings_config[3] == "" or vexbindings_config[3] == nil then
		print("|CFFFF7D0A Vex Bindings|r saveSpec is set to '"..vexbindings_config[3].."'. Binding-sets connected to specs will be loaded as temporariy bindings (will be resetted after the next loading screen!).")
	elseif vexbindings_config[3] == "s" then
		print("|CFFFF7D0A Vex Bindings|r saveSpec is set to '"..vexbindings_config[3].."'. Binding-sets connected to specs will be loaded as character specific bindings.")
	elseif vexbindings_config[3] == "g" then
		print("|CFFFF7D0A Vex Bindings|r saveSpec is set to '"..vexbindings_config[3].."'. Binding-sets connected to specs will be loaded as global bindings.")
	end
end

function vexbindings_OnEvent(self, event, arg1, arg2, ...)
	if event == "PLAYER_LOGIN" then
		vexbindings_Starter()
	elseif vexbindings.loaded and event == "ACTIVE_TALENT_GROUP_CHANGED" then
		local spec = vexbindings_GetSpecNumber()
		if vexbindings_config[spec] ~= nil then
			if vexbindings_list[vexbindings_config[spec]] ~= nil then
				local set = ""
				if vexbindings_config[3] ~= nil then
					set = vexbindings_config[3]
				end
				print("|CFFFF7D0A Vex Bindings|r Observing Spec change.")
				vexbindings_LoadBindingProfile(vexbindings_config[spec], set)
			else
				print("|CFFFF7D0A Vex Bindings|r Observing Spec change. ERROR: Could not load binding-set! REASON: Binding-set '"..vexbindings_config[spec].."' connected to spec '"..spec.."' doesn' exist!")
			end
		end
	end
end

function vexbindings_Starter()
	-- print("|CFFFF7D0AVex Bindings|r loaded")
	vexbindings_LoadDefaults()
	vexbindings.loaded = true
end

function vexbindings_LoadDefaults()
	if vexbindings_list == nil then
		vexbindings_list = {}
	end
	if vexbindings_config == nil then
		vexbindings_config = {}
	end
end

function vexbindings_ExistsBindingProfile(key)
	return vexbindings_list[key] ~= nil
end

function vexbindings_SaveBindingProfile(key)
	vexbindings_CollectBindings()
	vexbindings_list[key] = vexbindings_CopyTable(vexbindings.bindings)
	print("|CFFFF7D0A Vex Bindings|r Binding-Set '"..key.."' has been saved")
end

function vexbindings_ListBindingProfiles()
	local returnvalue = {}
	for key in pairs(vexbindings_list) do
		if key ~= nil then
			returnvalue[#returnvalue+1] = key
		end
	end
	table.sort(returnvalue, function (a,b) return a>b end)
	print("|CFFFF7D0A Vex Bindings|r Binding-Set List:")
	for i,v in ipairs(returnvalue) do
		print("Entry "..i..": "..v)
	end
end

function vexbindings_GetBindingSetName(set)
	local returnvalue = ""
	if set == "g" then
		returnvalue = "global key bindings (will be resetted after the next loading screen!)"
	elseif set == "s" then
		returnvalue = "character specific key bindings"
	else
		returnvalue = "temporariy key bindings"
	end
	return returnvalue
end

function vexbindings_NukeCurrentBindings()
	local keys = {}
	for i=1, GetNumBindings() do
		cmd, bind1, bind2 = GetBinding(i)
		if bind1 ~= nil then
			keys[#keys+1] = bind1
		end
		if bind2 ~= nil then
			keys[#keys+1] = bind2
		end
	end
	for i,val in ipairs(keys) do
		SetBinding(val)
	end
end

function vexbindings_LoadBindingProfile(key, set)
	if vexbindings_list[key] ~= nil then
		vexbindings_NukeCurrentBindings()
		for cmd, binding in pairs(vexbindings_list[key]) do
			if binding[1] ~= nil then
				local success1 = SetBinding(binding[1], cmd)
				if not(success1) then
					print("|CFFFF7D0A Vex Bindings|r ERROR: Could not bind '"..key.."' to key '"..binding[1])
				end
			end
			if binding[2] ~= nil then
				local success2 = SetBinding(binding[2], cmd)
				if not(success2) then
					print("|CFFFF7D0A Vex Bindings|r ERROR: Could not bind '"..key.."' to key '"..binding[2])
				end
			end
		end
		
		if set == "g" then
			SaveBindings(1)
		elseif set == "s" then
			SaveBindings(2)
		end
		print("|CFFFF7D0A Vex Bindings|r Binding-Set '"..key.."' has been loaded as: '"..vexbindings_GetBindingSetName(set).."'")
	else
		print("|CFFFF7D0A Vex Bindings|r ERROR: Could not load binding-set! REASON: Binding-Set '"..key.."' not found")
	end
end

function vexbindings_DeleteBindingProfile(key)
	if vexbindings_list[key] ~= nil then
		vexbindings_list[key] = nil
		print("|CFFFF7D0A Vex Bindings|r Binding-Set '"..key.."' has been deleted")
	else
		print("|CFFFF7D0A Vex Bindings|r ERROR: Could not delete binding-set! REASON: Binding-Set '"..key.."' not found")
	end
end

function vexbindings_ActivateBindingProfile(key)
	
end

function vexbindings_GetBinding(actionbar, button)
	local returnvalue = {nil, nil}
	if vexbindings.bindings[actionbar] ~= nil then
		if vexbindings.bindings[actionbar][button] ~= nil then
			if vexbindings.bindings[actionbar][button][1] ~= nil then
				returnvalue[1] = vexbindings.bindings[actionbar][button][1]
			end
			
			if vexbindings.bindings[actionbar][button][2] ~= nil then
				returnvalue[2] = vexbindings.bindings[actionbar][button][2]
			end
		end
	end
	return returnvalue
end

function vexbindings_NukeCollectedBindings()
	for key in pairs(vexbindings.bindings) do
		vexbindings.bindings[key] = nil
	end
end

function vexbindings_CollectBindings()
	vexbindings_NukeCollectedBindings()

	for i=1, GetNumBindings() do
		cmd, bind1, bind2 = GetBinding(i)
		vexbindings.bindings[cmd] = {bind1, bind2}
	end
end

function vexbindings_CopyTable(tabledata)
	local returnvalue = {}
	for key,val in pairs(tabledata) do
		if type(val) == "table" then 	returnvalue[key] = vexbindings_CopyTable(val)
		else							returnvalue[key] = val end
	end
	return returnvalue
end